#ifndef EVAL_CONST_H
#define EVAL_CONST_H

#include "eval_op.h"

typedef std::map<std::string, std::shared_ptr<eval_op>> eval_op_proto_map;

class eval_const: public eval_op {
    tensor value_;
    std::shared_ptr<eval_op> clone(const expression &expr) override;
public:
    eval_const() {}
    eval_const(const expression &expr);
    void eval(vars_type &variables, const kwargs_type &kwargs) override;
    static void store_prototype(eval_op_proto_map &proto_map) {
        assert(proto_map.find("Const") == proto_map.end());
        proto_map["Const"] = std::make_shared<eval_const>(); // where is expr?
    }
}; // class eval_const

#endif